## libelfin 0.3

=== Makefile ===
all:
	$(MAKE) -C elf
	$(MAKE) -C dwarf

install:
	$(MAKE) -C elf install
	$(MAKE) -C dwarf install

clean:
	$(MAKE) -C elf clean
	$(MAKE) -C dwarf clean

check:
	cd test && ./test.sh

=== dwarf/Makefile ===
# Changed when ABI backwards compatibility is broken.
# Typically uses the major version.
SONAME = 0

CXXFLAGS+=-g -O2 -Werror
override CXXFLAGS+=-std=c++0x -Wall -fPIC

all: libdwarf++.a libdwarf++.so.$(SONAME) libdwarf++.so libdwarf++.pc

SRCS := dwarf.cc cursor.cc die.cc value.cc abbrev.cc \
	expr.cc rangelist.cc line.cc attrs.cc \
	die_str_map.cc elf.cc to_string.cc
HDRS := dwarf++.hh data.hh internal.hh small_vector.hh ../elf/to_hex.hh
CLEAN :=

libdwarf++.a: $(SRCS:.cc=.o)
	ar rcs $@ $^
CLEAN += libdwarf++.a $(SRCS:.cc=.o)

$(SRCS:.cc=.o): $(HDRS)

to_string.cc: ../elf/enum-print.py dwarf++.hh data.hh Makefile
	@echo "// Automatically generated by make at $$(date)" > to_string.cc
	@echo "// DO NOT EDIT" >> to_string.cc
	@echo >> to_string.cc
	@echo '#include "internal.hh"' >> to_string.cc
	@echo >> to_string.cc
	@echo 'DWARFPP_BEGIN_NAMESPACE' >> to_string.cc
	@echo >> to_string.cc
	python3 ../elf/enum-print.py < dwarf++.hh >> to_string.cc
	python3 ../elf/enum-print.py -s _ -u --hex -x hi_user -x lo_user < data.hh >> to_string.cc
	@echo 'DWARFPP_END_NAMESPACE' >> to_string.cc
CLEAN += to_string.cc

libdwarf++.so.$(SONAME): $(SRCS:.cc=.o)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^
CLEAN += libdwarf++.so.*

libdwarf++.so:
	ln -s $@.$(SONAME) $@
CLEAN += libdwarf++.so

# Create pkg-config for local library and headers. This will be
# transformed in to the correct global pkg-config by install.
libdwarf++.pc: always
	@(VER=$$(git describe --match 'v*' | sed -e s/^v//); \
	  echo "libdir=$$PWD"; \
	  echo "includedir=$$PWD"; \
	  echo ""; \
	  echo "Name: libdwarf++"; \
	  echo "Description: C++11 DWARF library"; \
	  echo "Version: $$VER"; \
	  echo "Requires: libelf++ = $$VER"; \
	  echo "Libs: -L\$${libdir} -ldwarf++"; \
	  echo "Cflags: -I\$${includedir}") > $@
CLEAN += libdwarf++.pc

.PHONY: always

PREFIX?=/usr/local

install: libdwarf++.a libdwarf++.so.$(SONAME) libdwarf++.so libdwarf++.pc
	install -d $(PREFIX)/lib/pkgconfig
	install -t $(PREFIX)/lib libdwarf++.a
	install -t $(PREFIX)/lib libdwarf++.so.$(SONAME)
	install -t $(PREFIX)/lib libdwarf++.so
	install -d $(PREFIX)/include/libelfin/dwarf
	install -t $(PREFIX)/include/libelfin/dwarf data.hh dwarf++.hh small_vector.hh
	sed 's,^libdir=.*,libdir=$(PREFIX)/lib,;s,^includedir=.*,includedir=$(PREFIX)/include,' libdwarf++.pc \
		> $(PREFIX)/lib/pkgconfig/libdwarf++.pc

clean:
	rm -f $(CLEAN)

.DELETE_ON_ERROR:

=== elf/Makefile ===
# Changed when ABI backwards compatibility is broken.
# Typically uses the major version.
SONAME = 0

CXXFLAGS+=-g -O2 -Werror
override CXXFLAGS+=-std=c++0x -Wall -fPIC

all: libelf++.a libelf++.so libelf++.so.$(SONAME) libelf++.pc

SRCS := elf.cc mmap_loader.cc to_string.cc
HDRS := elf++.hh data.hh common.hh to_hex.hh
CLEAN :=

libelf++.a: $(SRCS:.cc=.o)
	ar rcs $@ $^
CLEAN += libelf++.a $(SRCS:.cc=.o)

$(SRCS:.cc=.o): $(HDRS)

to_string.cc: enum-print.py data.hh Makefile
	@echo "// Automatically generated by make at $$(date)" > to_string.cc
	@echo "// DO NOT EDIT" >> to_string.cc
	@echo >> to_string.cc
	@echo '#include "data.hh"' >> to_string.cc
	@echo '#include "to_hex.hh"' >> to_string.cc
	@echo >> to_string.cc
	@echo 'ELFPP_BEGIN_NAMESPACE' >> to_string.cc
	@echo >> to_string.cc
	python3 enum-print.py -u --hex --no-type --mask shf --mask pf \
		-x loos -x hios -x loproc -x hiproc < data.hh >> to_string.cc
	@echo 'ELFPP_END_NAMESPACE' >> to_string.cc
CLEAN += to_string.cc

libelf++.so.$(SONAME): $(SRCS:.cc=.o)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^
CLEAN += libelf++.so.*

libelf++.so:
	ln -s $@.$(SONAME) $@
CLEAN += libelf++.so

# Create pkg-config for local library and headers. This will be
# transformed in to the correct global pkg-config by install.
libelf++.pc: always
	@(VER=$$(git describe --match 'v*' | sed -e s/^v//); \
	  echo "libdir=$$PWD"; \
	  echo "includedir=$$PWD"; \
	  echo ""; \
	  echo "Name: libelf++"; \
	  echo "Description: C++11 ELF library"; \
	  echo "Version: $$VER"; \
	  echo "Libs: -L\$${libdir} -lelf++"; \
	  echo "Cflags: -I\$${includedir}") > $@
CLEAN += libelf++.pc

.PHONY: always

PREFIX?=/usr/local

install: libelf++.a libelf++.so libelf++.so.$(SONAME) libelf++.pc
	install -d $(PREFIX)/lib/pkgconfig
	install -t $(PREFIX)/lib libelf++.a
	install -t $(PREFIX)/lib libelf++.so.$(SONAME)
	install -t $(PREFIX)/lib libelf++.so
	install -d $(PREFIX)/include/libelfin/elf
	install -t $(PREFIX)/include/libelfin/elf common.hh data.hh elf++.hh
	sed 's,^libdir=.*,libdir=$(PREFIX)/lib,;s,^includedir=.*,includedir=$(PREFIX)/include,' libelf++.pc \
		> $(PREFIX)/lib/pkgconfig/libelf++.pc

clean:
	rm -f $(CLEAN)

.DELETE_ON_ERROR:

=== examples/Makefile ===
CXXFLAGS+=-g -O2 -Werror
override CXXFLAGS+=-std=c++0x -Wall

CLEAN :=

all: dump-sections dump-segments dump-syms dump-tree dump-lines find-pc

# Find libs
export PKG_CONFIG_PATH=../elf:../dwarf
CPPFLAGS+=$$(pkg-config --cflags libelf++ libdwarf++)
# Statically link against our libs to keep the example binaries simple
# and dependencies correct.
LIBS=../dwarf/libdwarf++.a ../elf/libelf++.a

# Dependencies
CPPFLAGS+=-MD -MP -MF .$@.d
-include .*.d

dump-sections: dump-sections.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += dump-sections dump-sections.o

dump-segments: dump-segments.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += dump-segments dump-segments.o

dump-syms: dump-syms.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += dump-syms dump-syms.o

dump-tree: dump-tree.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += dump-tree dump-tree.o

dump-lines: dump-lines.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += dump-lines dump-lines.o

find-pc: find-pc.o $(LIBS)
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@
CLEAN += find-pc find-pc.o

clean:
	rm -f $(CLEAN) .*.d

=== debian/changelog ===
libelfin (0.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Remove const qualifier from setter (Closes: #953618,
    #976450)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 06 Dec 2020 12:44:01 +0100

libelfin (0.3-2) unstable; urgency=medium

  [ Lluís Vilanova ]
  * Update Vcs urls in debian/control to point to salsa.debian.org
  * Update contact email for Lluís Vilanova
  * Update to standards version 4.4.0

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 02 Sep 2020 18:49:43 +0200

libelfin (0.3-1) unstable; urgency=medium

  * New upstream version 0.3.
    - Removed 0002-portable-uint64-print.patch and 0003-big-endian.patch
      merged upstream.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 03 Dec 2016 08:41:12 +0000

libelfin (0.2-6) unstable; urgency=medium

  * Added 0003-big-endian.patch from upstream to work on big endian
    architectures.  (Closes: #844465)

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 02 Dec 2016 22:43:18 +0000

libelfin (0.2-5) unstable; urgency=medium

  * Added patch 0002-portable-uint64-print.patch to fix unportable printf().

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 15 Nov 2016 14:21:25 +0000

libelfin (0.2-4) unstable; urgency=medium

  * Dropped git build dependency, it is not needed thanks to
    0001-Let-d-rules-override-library-version.patch.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 13 Nov 2016 08:41:31 +0000

libelfin (0.2-3) unstable; urgency=medium

  * Corrected python build dependency to use python3-minimal.
  * Added missing pkg-config build dependency.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 12 Nov 2016 08:13:57 +0000

libelfin (0.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 11 Nov 2016 14:16:01 +0000

libelfin (0.2-1) experimental; urgency=medium

  [ Lluís Vilanova ]
  * Update to latest upstream.
  * New upstream version have new SONAME, adjust package names to match.

  [ Petter Reinholdtsen ]
  * Upload to experimental with the new package names.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 04 Oct 2016 09:45:29 +0200

libelfin (0.1+20160825.git.6eb10ca-6) unstable; urgency=medium

  * Extended autopkgtest to use both gcc and clang, to expose problem
    with c++11 symbols.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 02 Oct 2016 08:58:11 +0000

libelfin (0.1+20160825.git.6eb10ca-5) unstable; urgency=medium

  * Added d/clean to remove generated files after build.
  * Adjusted 0002-Add-support-for-dynamic-linking-with-libelf-and-libd.patch
    and d/rules to get working pkg-config setup (Closes: #839287).

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 01 Oct 2016 15:12:15 +0000

libelfin (0.1+20160825.git.6eb10ca-4) unstable; urgency=medium

  * Added simple autopkgtest scripts to check if pkg-config and
    compiling work.
  * Added missing git build dependency to get version number in
    pkg-config files.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 30 Sep 2016 21:36:02 +0000

libelfin (0.1+20160825.git.6eb10ca-3) unstable; urgency=medium

  [ Lluís Vilanova ]
  * Fix pattern to auto-detect package names

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Sep 2016 20:54:54 +0000

libelfin (0.1+20160825.git.6eb10ca-2) unstable; urgency=medium

  * Add missing python-minimal (<< 3) build dependency.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Sep 2016 08:47:27 +0000

libelfin (0.1+20160825.git.6eb10ca-1) unstable; urgency=low

  [ Lluís Vilanova ]
  * Initial upload (closes: #834123).

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 12 Sep 2016 20:29:19 +0200

=== debian/control ===
Source: libelfin
Section: libdevel
Priority: optional
Maintainer: Lluís Vilanova <llvilanovag@gmail.com>
Uploaders: Petter Reinholdtsen <pere@debian.org>
Build-Depends: debhelper (>= 9~)
 , dh-exec (>= 0.3)
 , g++ (>= 4.7)
 , python3-minimal
 , pkg-config
Standards-Version: 4.4.0
Homepage: https://github.com/aclements/libelfin
Vcs-Browser: https://salsa.debian.org/coz-team/libelfin
Vcs-Git: https://salsa.debian.org/coz-team/libelfin.git

# NOTE: We provide separate "libelf++" and "libdwarf++" packages to let their
# libraries evolve their ABI / SONAME independently.

Package: libelf++0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++11 ELF parser
 Libelfin is a from-scratch C++11 library for reading ELF binaries and DWARFv4
 debug information.
 .
 Libelfin implements a syntactic layer for DWARF and ELF, but not a semantic
 layer. Interpreting the information stored in DWARF DIE trees still requires a
 great deal of understanding of DWARF, but libelfin will make sense of the bytes
 for you.
 .
 This package contains the library to parse ELF binaries.

Package: libdwarf++0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libelf++0 (= ${binary:Version})
Description: C++11 DWARF parser
 Libelfin is a from-scratch C++11 library for reading ELF binaries and DWARFv4
 debug information.
 .
 Libelfin implements a syntactic layer for DWARF and ELF, but not a semantic
 layer. Interpreting the information stored in DWARF DIE trees still requires a
 great deal of understanding of DWARF, but libelfin will make sense of the bytes
 for you.
 .
 This package contains the library to parse DWARFv4 debug information.

Package: libelfin-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libdwarf++0 (= ${binary:Version})
Description: C++11 ELF/DWARF parser (development files)
 Libelfin is a from-scratch C++11 library for reading ELF binaries and DWARFv4
 debug information.
 .
 Libelfin implements a syntactic layer for DWARF and ELF, but not a semantic
 layer. Interpreting the information stored in DWARF DIE trees still requires a
 great deal of understanding of DWARF, but libelfin will make sense of the bytes
 for you.
 .
 This package contains development libraries and header files for libelfin.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment to turn on verbose mode
export DH_VERBOSE=1

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# upstream does not use CPPFLAGS
CXXFLAGS += $(CPPFLAGS)

LIBVERSION = $(shell dpkg-parsechangelog -S version)

define PKGNAME
$(strip $(shell grep -E '^Package: lib$(1)\+\+.+$$' debian/control | cut -f 2 -d ':'))
endef

define LIBFILE
$(patsubst debian/$(1)/%,%,$(wildcard debian/$(1)/usr/lib/$(DEB_HOST_MULTIARCH)/lib$(2)++.so.*))
endef

export LIBELFXX_PKG = $(call PKGNAME,elf)
export LIBELFXX
export LIBDWARFXX_PKG = $(call PKGNAME,dwarf)
export LIBDWARFXX


%:
	dh $@

override_dh_auto_build:
	@echo $(CFLAGS)
	@echo $(CXXFLAGS)
	@echo $(LDFLAGS)
	dh_auto_build -- LIBVERSION=$(LIBVERSION)

override_dh_auto_install:
	$(MAKE) install PREFIX=$(CURDIR)/debian/tmp/usr LIBVERSION=$(LIBVERSION)
	sed -i -e 's|libdir=.*|libdir=/usr/lib/$(DEB_HOST_MULTIARCH)|' \
		$(CURDIR)/debian/tmp/usr/lib/pkgconfig/*.pc
	sed -i -e 's|includedir=.*|includedir=/usr/include/libelfin|' \
		$(CURDIR)/debian/tmp/usr/lib/pkgconfig/*.pc

override_dh_link: LIBELFXX=$(call LIBFILE,$(LIBELFXX_PKG),elf)
override_dh_link: LIBDWARFXX=$(call LIBFILE,$(LIBDWARFXX_PKG),dwarf)
override_dh_link:
	dh_link

override_dh_auto_clean:
	$(MAKE) clean
	$(MAKE) -C examples clean

=== debian/tests/control ===
Tests: test-build-libelf++ test-build-libdwarf++
Depends: @, pkg-config, clang
